#
# (ɤ)ץ Bread  桼󥿥ե Fox 
#
# by Noritsugu Nakamura

require "fox"
require "fox/responder"
require "uconv"

include Fox
include Responder

# Tk ߴ󥿥ե
module Fox
  def tr(txt)
    Uconv.euctou8(txt)
  end

  class FXLabel
    def text(txt)
      self.setText(tr(txt))
    end
  end
  class FXTextField
    def value
      txt = Uconv.u8toeuc(self.getText)
    end
    alias value= setText
  end
end

class FX_Help < FXDialogBox
  ID_OK, ID_LAST = enum(FXMainWindow::ID_LAST, 2)

  def initialize(parent, title, text_)
    super(parent, tr(title), DECOR_TITLE|DECOR_BORDER, 0, 0, 700, 500)

    #FXMAPFUNC(SEL_COMMAND, ID_OK, "onClose")

    vbox = FXVerticalFrame.new(self, LAYOUT_FILL_X|LAYOUT_FILL_Y)

    text = FXText.new(vbox, nil, 0, LAYOUT_FILL_X|LAYOUT_FILL_Y)
    text.text=(tr(text_))

    FXButton.new(vbox, tr("Ĥ"), nil, self, ID_OK, FRAME_RAISED|FRAME_THICK|LAYOUT_RIGHT)

    execute
    #show

    text.setFocus
  end
end

module UI_FX

  class Variable
    def initialize
      @value = ""
    end
    def value=(v)
      @value = v
    end
    attr_reader :value
  end
  COURSE = Variable.new

  ID_COURSE1, ID_COURSE2, ID_COURSE3, ID_COURSE4, ID_COURSE5, ID_COURSE,
    ID_ABOUT, ID_USAGE, ID_EXP_BRAILLE,
    ID_ENTRY, ID_TIMER, ID_LAST = enum(FXMainWindow::ID_LAST, 12)

  class Win < FXMainWindow
    include Responder

    def initialize(b, m, *args)
      @b = b
      @m = m
      super(*args)

      FXMAPFUNCS(SEL_COMMAND, ID_COURSE1, ID_COURSE5, "onCourse")
      FXMAPFUNCS(SEL_COMMAND, ID_COURSE1, ID_COURSE, "change_outotu")

      FXMAPFUNC(SEL_COMMAND, ID_ABOUT, "about")
      FXMAPFUNC(SEL_COMMAND, ID_USAGE, "usage")
      FXMAPFUNC(SEL_COMMAND, ID_EXP_BRAILLE, "exp_braille")

      FXMAPFUNC(SEL_KEYPRESS, ID_ENTRY, "onKeyPress")
      FXMAPFUNC(SEL_TIMEOUT, ID_TIMER, "onCmdTimer")
    end

    def onCourse(sender, sel, ptr)
      @m.each { |mc| mc.uncheckRadio }
      sender.checkRadio
      case SELID(sel)
      when ID_COURSE1
        @b.change_course("50")
      when ID_COURSE2
        @b.change_course("ٹ")
      when ID_COURSE3
        @b.change_course("ü첻")
      when ID_COURSE4
        @b.change_course("")
      when ID_COURSE5
        @b.change_course("ե٥å")
      end
      @b.set_focus
      return 1
    end

    def change_outotu(sender, sel, ptr)
      @b.change_outotu
      @b.set_focus
    end

    def about(sender, sel, ptr)
      FXMessageBox.information(self, MBOX_OK, "About Bread", tr(COPYRIGHT))
      @b.set_focus
      return 1
    end

    def usage(sender, sel, ptr)
      FX_Help.new(self, "Ȥ", Bread::USAGE)
      @b.set_focus
      return 1
    end

    def exp_braille(sender, sel, ptr)
      FX_Help.new(self, "ɽ", Bread::TABLE)
      @b.set_focus
      return 1
    end

    def onKeyPress(sender, sel, ptr)
      if ptr.code == 65293 # Enter 
        @b.answer_check
        return 1
      else
        return 0
      end
    end

    def onCmdTimer(sender, sel, ptr)
      #@timer = getApp().addTimeout(2000, self, ID_TIMER)
      @b.nextq
    end
  end

  def init
    @app = FXApp.new  
    @app.init(ARGV)

    m_ary = Array.new

    @win = Win.new(self, m_ary, @app, TITLE, nil, nil, DECOR_ALL,
                   0, 0, 0, 0, 0, 0, 0, 0,
                   0, 15)

    # ˥塼
    menubar = FXMenubar.new(@win, LAYOUT_SIDE_TOP|LAYOUT_FILL_X)

    filemenu = FXMenuPane.new(@win)
    FXMenuCommand.new(filemenu, "&Quit\tCtl-Q", nil, @win.getApp(), FXApp::ID_QUIT)
    FXMenuTitle.new(menubar, "&File", nil, filemenu)

    coursemenu = FXMenuPane.new(@win)
    m_ary << FXMenuCommand.new(coursemenu, tr("50ѹ"), nil, @win, ID_COURSE1, 0)
    m_ary << FXMenuCommand.new(coursemenu, tr("ٹѹ"), nil, @win, ID_COURSE2, 0)
    m_ary << FXMenuCommand.new(coursemenu, tr("ü첻ѹ"), nil, @win, ID_COURSE3, 0)
    m_ary << FXMenuCommand.new(coursemenu, tr("ѹ"), nil, @win, ID_COURSE4, 0)
    m_ary << FXMenuCommand.new(coursemenu, tr("ե٥åȤѹ"), nil, @win, ID_COURSE5, 0)
    FXMenuSeparator.new(coursemenu)
    FXMenuCommand.new(coursemenu, tr("̤ѹ"), nil, @win, ID_COURSE)
    FXMenuTitle.new(menubar, "&Course", nil, coursemenu)
    m_ary[0].checkRadio
    
    helpmenu = FXMenuPane.new(@win)
    FXMenuCommand.new(helpmenu, "&About...", nil, @win, ID_ABOUT, 0)
    FXMenuCommand.new(helpmenu, tr("Ȥ"), nil, @win, ID_USAGE, 0)
    FXMenuCommand.new(helpmenu, tr("ɽ"), nil, @win, ID_EXP_BRAILLE, 0)
    FXMenuTitle.new(menubar, "&Help", nil, helpmenu)

    # ᥤ
    @title = FXLabel.new(@win, tr(" 50  "),
                                             nil, JUSTIFY_CENTER_X|LAYOUT_FILL_X)

    @braille1 = FXLabel.new(@win, tr(""),
                            nil, JUSTIFY_CENTER_X|LAYOUT_FILL_X)
    @braille2 = FXLabel.new(@win, tr(""),
                            nil, JUSTIFY_CENTER_X|LAYOUT_FILL_X)
    @braille3 = FXLabel.new(@win, tr(""),
                            nil, JUSTIFY_CENTER_X|LAYOUT_FILL_X)

    @entry = FXTextField.new(@win, 30,
                             @win, ID_ENTRY, FRAME_SUNKEN|FRAME_THICK) 

    @yosidame = FXLabel.new(@win, "", nil, JUSTIFY_CENTER_X|LAYOUT_FILL_X)

    hbox = FXHorizontalFrame.new(@win, LAYOUT_SIDE_BOTTOM|LAYOUT_FILL_X)

    yoshi = FXLabel.new(hbox, tr(""), nil, JUSTIFY_CENTER_X|LAYOUT_FILL_X)
    @l_yosi = FXLabel.new(hbox, "0", nil, JUSTIFY_CENTER_X|LAYOUT_FILL_X)

    dame = FXLabel.new(hbox, tr(""), nil, JUSTIFY_CENTER_X|LAYOUT_FILL_X)
    @l_dame = FXLabel.new(hbox, "0", nil, JUSTIFY_CENTER_X|LAYOUT_FILL_X)

    # ΤȤ˥ե
    @entry.setFocus
  end

  def main_loop
    @app.create
    @win.show(PLACEMENT_SCREEN)
    @app.run
  end

  def sleep_
    @win.getApp().addTimeout(2000, @win, ID_TIMER)
    #nextq
  end

  def set_focus
    @entry.setFocus
  end
end
