#
# (ɤ)ץ Bread  桼󥿥ե Qt 
#
# by Noritsugu Nakamura

require "qt2"
include Qt2

# Tk ߴ󥿥ե
module Qt2
  class QLabel
    def text(txt)
      self.setText(tr(txt))
    end
  end
  class QLineEdit
    def value
      txt = self.text
      txt.local8Bit.to_str # Ruby String Ѵ
    end
    alias value= setText
  end
end

class Qt_Help < QDialog
  def initialize(parent, title, text_)
    super(parent, nil, false)
    setCaption(tr(title))

    vbox = QVBox.new(self)
    vbox.setGeometry(0, 0, 700, 500)
    vbox.setMargin(10)

    text = QMultiLineEdit.new(vbox)
    text.setText(tr(text_))

    button = QPushButton.new(tr("Ĥ"), vbox)
    Qt2::connect(button, QSIGNAL('clicked()'), self, 'close')

    text.setFocus

    show
  end
end

module UI_Qt

  class Variable
    def initialize
      @value = ""
    end
    def value=(v)
      @value = v
    end
    attr_reader :value
  end
  COURSE = Variable.new
  def init
    @a = QApplication.new([TITLE])
    codec = QTextCodec::codecForLocale()
    @a.setDefaultCodec(codec)

    @vbox = QVBox.new
    @vbox.setMargin(10)
    @a.setMainWidget(@vbox)

    # ˥塼
    menu_file = QPopupMenu.new()
    menu_file.insertItem("Exit", QApplication::qApp, "quit()", Qt::CTRL+Qt::Key_Q)

    @menu_course = QPopupMenu.new()
    @menu_course.insertItem(tr("50ѹ"), self, "course1", nil, 1)
    @menu_course.insertItem(tr("ٹѹ"), self, "course2", nil, 2)
    @menu_course.insertItem(tr("ü첻ѹ"), self, "course3", nil, 3)
    @menu_course.insertItem(tr("ѹ"), self, "course4", nil, 4)
    @menu_course.insertItem(tr("ե٥åȤѹ"), self, "course5", nil, 5)
    @menu_course.insertSeparator
    @menu_course.insertItem(tr("̤ѹ"), self, "change_outotu")
    @menu_course.setItemChecked(1, true)

    menu_help = QPopupMenu.new()
    menu_help.insertItem("&About...", self, "about", Qt::Key_F1)
    menu_help.insertItem(tr("Ȥ"), self, "usage")
    menu_help.insertItem(tr("ɽ"), self, "exp_braille")

    menubar = QMenuBar.new(@vbox)
    menubar.insertItem("&File", menu_file)
    menubar.insertItem("&Course", @menu_course)
    menubar.insertItem("&Help", menu_help)

    # ᥤ
    @title = QLabel.new(tr(" 50  "), @vbox)
    @title.setAlignment(Qt::AlignCenter)

    @braille1 = QLabel.new("", @vbox)
    @braille1.setAlignment(Qt::AlignCenter)

    @braille2 = QLabel.new("", @vbox)
    @braille2.setAlignment(Qt::AlignCenter)

    @braille3 = QLabel.new("", @vbox)
    @braille3.setAlignment(Qt::AlignCenter)

    @entry = QLineEdit.new("", @vbox)

    @yosidame = QLabel.new("", @vbox)
    @yosidame.setAlignment(Qt::AlignCenter)

    hbox = QHBox.new(@vbox)

    yoshi = QLabel.new(tr(""), hbox)
    @l_yosi = QLabel.new("0", hbox)

    dame = QLabel.new(tr(""), hbox)
    @l_dame = QLabel.new("0", hbox)
    

	@a.setMainWidget(@vbox)
    @vbox.show()

    # ΤȤ˥ե
    @entry.setFocus

    Qt2::connect(@entry, QSIGNAL('returnPressed()'), self, 'answer_check')
  end

  def main_loop
	@a.exec()
  end

  def sleep_
    @time = Time.new
    @timer = QTimer.new
    connect( @timer, QSIGNAL("timeout()"), self, "timeout" )
    @timer.start(100)

    #nextq
  end

  def timeout
    if (Time.new - @time) > 2
      @timer.stop
      nextq
    else
    end
  end

  def course_clear
    1.upto(5) {|i| @menu_course.setItemChecked(i, false)}
  end

  def course1
    change_course("50")
    course_clear; @menu_course.setItemChecked(1, true)
  end
  def course2
    change_course("ٹ")
    course_clear; @menu_course.setItemChecked(2, true)
  end
  def course3
    change_course("ü첻")
    course_clear; @menu_course.setItemChecked(3, true)
  end
  def course4
    change_course("")
    course_clear; @menu_course.setItemChecked(4, true)
  end
  def course5
    change_course("ե٥å")
    course_clear; @menu_course.setItemChecked(5, true)
  end

  def about
    QMessageBox::about( @vbox, "About Bread", tr(COPYRIGHT))
  end

  # Ȥ
  def usage
    # widget ¸ߤ˴
#    if $w_usage
#      $w_usage.close
#    end
    $w_usage = Qt_Help.new(@vbox, "Ȥ", Bread::USAGE)
  end

  # ɽ
  def exp_braille
    # widget ¸ߤ˴
#    if $w_exp
#      $w_exp.close
#    end
    $w_exp = Qt_Help.new(@vbox, "ɽ", Bread::TABLE)
  end
end
